



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Reactor 模式的简单实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Reactor 模式的简单实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-26 20:06:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Reactor 模式简单实现</p>
<p>在网上有部分文章在描述Netty时，会提到Reactor。这个Reactor到底是什么呢？为了搞清楚Reactor到底是什么鬼，我写了一个简单的Demo，来帮助大家理解他。</p>
<p>网上是这么描述Reactor的：</p>
<p>The Reactor design pattern handles service requests that are delivered concurrently to an application by one or more clients.</p>
<p>Each service in an application may consist of serveral methods and is represented by a separate event handler that is responsible for dispatching service-specific requests.</p>
<p>Dispatching of event handlers is performed by an initiation dispatcher, which manages the registered event handlers. Demultiplexing of service requests is performed by a synchronous event demultiplexer.</p>
<p>大致意思是：Reactor是用于处理多个客户端的请求的设计模式。应用程序提供的每一种服务都可能包括多个方法，并且有必要为这每一个服务分配独立的请求处理器（也可以说是 event handler）。对于Event handler的调度是有Dispatcher来执行的，这个Dispatcher可以管理event handler的注册工作。而分离器Demultiplexer则将一个服务分成了多份。这段话看起来还是不那么容易理解的。</p>
<p>我对这段话的理解是：应用程序提供多种服务，而每一种服务都会分为多步骤（或者多类别）进行。这里将每一步都作为一个事件，那么每一步的处理就认为是一个event handler。Dispatcher管理这多个步骤的处理器，也即dispatcher管理着多个Event Handler。而将一个服务处理分为多步骤（多个类别）的处理的工作则是有分离器来完成。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/512650/201607/512650-20160717234934795-1357151898.png" /></p>
<p>从这个类图上看，主要有四个角色：</p>
<p>&middot;Handle：事件源。</p>
<p>&middot;EventHandler：事件处理器</p>
<p>&middot;Dispatcher：调度器。使用Demultiplexer选出可以执行处理的EventHandler，然后执行对EventHandler的调度。</p>
<p>&middot;Demultiplexer：同步的事件分离器。</p>
<p>从类图上看：Dispatcher中有一个Selector和一个EventHandler集合（可以是List，也可以是Map，具体怎么实现根据实际需求）。Regist_handler、remove_handler用于管理EventHandler。</p>
<p>Handle_events用于启动调度，这个方法的实现通常是：使用分离器选择出可以调度的Event，然后对它们进行调度。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/512650/201607/512650-20160717234948764-361725338.png" /></p>
<p>下面就是对Reactor模式的简单实现：</p>
<div>
<pre class="prettyprint linenums">package com.fjn.jdk.nio.reactor.standard;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.LinkedBlockingQueue;

public class StandardReactor {

}

class EventDispatcher {
    Map&lt;EventType, EventHandler&gt; eventHandlerMap = new ConcurrentHashMap&lt;EventType, EventHandler&gt;();

    Demultiplexer selector;

    EventDispatcher(Demultiplexer selector) {
        this.selector = selector;
    }

    public void registEventHandler(EventType eventType, EventHandler eventHandler) {
        eventHandlerMap.put(eventType, eventHandler);

    }

    public void removeEventHandler(EventType eventType) {
        eventHandlerMap.remove(eventType);
    }

    public void handleEvents() {
        dispatch();
    }

    private void dispatch() {
        while (true) {
            List&lt;Event&gt; events = selector.select();

            for (Event event : events) {
                EventHandler eventHandler = eventHandlerMap.get(event.type);
                eventHandler.handle(event);
            }
        }
    }
}

class Demultiplexer {
    private BlockingQueue&lt;Event&gt; eventQueue = new LinkedBlockingQueue&lt;Event&gt;();
    private Object lock = new Object();

    List&lt;Event&gt; select() {
        return select(0);
    }

    List&lt;Event&gt; select(long timeout) {
        if (timeout &gt; 0) {
            if (eventQueue.isEmpty()) {
                synchronized (lock) {
                    if (eventQueue.isEmpty()) {
                        try {
                            lock.wait(timeout);
                        } catch (InterruptedException e) {
                            // ignore it
                        }
                    }
                }

            }
        }
        List&lt;Event&gt; events = new ArrayList&lt;Event&gt;();
        eventQueue.drainTo(events);
        return events;
    }

    public void addEvent(Event e) {
        boolean success = eventQueue.offer(e);
        if (success) {
            synchronized (lock) {
                lock.notify();
            }

        }
    }

}

class Source {
    private Date date = new Date();
    private String id = date.toString() + "_" + System.identityHashCode(date);

    @Override
    public String toString() {
        return id;
    }
}

enum EventType {
    ACCEPT, READ, WRITE, TIMEOUT;
}

class Event {
    public EventType type;
    public Source source;
}

abstract class EventHandler {
    Source source;

    public abstract void handle(Event event);

    public Source getSource() {
        return source;
    }
}

class AcceptEventHandler extends EventHandler {

    private Demultiplexer selector;

    public AcceptEventHandler(Demultiplexer selector) {
        this.selector = selector;
    }

    @Override
    public void handle(Event event) {
        if (event.type == EventType.ACCEPT) {

            Event readEvent = new Event();
            readEvent.source = event.source;
            readEvent.type = EventType.READ;

            selector.addEvent(readEvent);
        }
    }

}

class ReadEventHandler extends EventHandler {
    // private Pipeline pipeline;

    @Override
    public void handle(Event event) {
        // create channel with a pipeline
        // register the channel to this event dispatcher or a child event dispatcher 

        // handle event use the pipeline :
        // step 1:  read to a frame buffer
        // step 2:  use frame decoder to decode buffer as a message (maybe a business object)
        // step 3:  handle the message or submit the message to business thread pool
        // step 4:  register a message event

    }

} 

class WriteEventHandler extends EventHandler {

    @Override
    public void handle(Event event) {
        // step 1: encode a message to byte[]
        // step 2: submit a write task to IOWorker thread pool
    }

}

//-------------------------------分割线--------------------------//

class Acceptor implements Runnable {
    private int port; // server socket port
    private Demultiplexer selector;

    // 代表 serversocket
    private BlockingQueue&lt;Source&gt; sourceQueue = new LinkedBlockingQueue&lt;Source&gt;();

    Acceptor(Demultiplexer selector, int port) {
        this.selector = selector;
        this.port = port;
    }

    public void aNewConnection(Source source) {
        sourceQueue.offer(source);
    }

    public int getPort() {
        return this.port;
    }

    public void run() {
        while (true) {

            Source source = null;
            try {
                // 相当于 serversocket.accept()
                source = sourceQueue.take();
            } catch (InterruptedException e) {
                // ignore it;
            }

            if (source != null) {
                Event acceptEvent = new Event();
                acceptEvent.source = source;
                acceptEvent.type = EventType.ACCEPT;

                selector.addEvent(acceptEvent);
            }

        }
    }

}

class Server {
    Demultiplexer selector = new Demultiplexer();
    EventDispatcher eventLooper = new EventDispatcher(selector);
    Acceptor acceptor;

    Server(int port) {
        acceptor = new Acceptor(selector, port);
    }

    public void start() {
        eventLooper.registEventHandler(EventType.ACCEPT, new AcceptEventHandler(selector));
        new Thread(acceptor, "Acceptor-" + acceptor.getPort()).start();
        eventLooper.handleEvents();
    }

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pe1d8x.html">C&num;学习总结之集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z2znd8.html">ACM&sol;ICPC 之 DP-基因相似度&lpar;POJ1080-ZOJ1027&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w02nvq.html">浅析vb&period;net与vb6的不同</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxwx38.html">原生JS 选项卡代码实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwo0xq.html">WPF应用程序支持多国语言解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjz21y8.html">TPYBoard v102 驱动28BYJ-48步进电机</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz5png8.html">python numpy和pandas做数据分析时去掉科学记数法显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1x4xxq.html">LOCAL&lowbar;EXPORT&lowbar;&amp;&num;215&semi;&amp;&num;215&semi;用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzyvrw8.html">如何追踪产生大量REDO的来源</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11nyeq.html">SEO常用命令大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjvd59.html">两张图彻底搞懂MyBatis的Mapper原理！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj5v179.html">NBU将RAC数据库恢复到单机</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m24mlrq.html">Zookeeper&plus;Kafka集群部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwv3rj9.html">使用反向代理的http的请求流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/960wlw49.html">vue路由6：导航钩子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll6lpeq.html">Azure ARM &lpar;22&rpar; 使用Azure PowerShell创建Azure RM VM</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g2lj6q.html">linux命令之vi文本编辑器</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rok5j9.html">Vsftpd完全攻略（三）基于系统用户支持ftp上传 访问和vsftp安全设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjwm3zq.html">Cloud Resource</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pkg15q.html">1112 Stucked Keyboard （20 分）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq12mz9g.html">Html&amp;lt&semi;a&amp;gt&semi;标签href的困惑记载</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwxzk97.html">PHP安全之Web攻击</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k4e59j.html">通过easyui tab添加的子页面JS脚本必须放在body才生效</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r36790.html">MongoDB高级查询详细</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j64wq5.html">SubSonic3&period;0使用存储过程查询时，不能使用output参数返回值的问题修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/4951nzqz.html">C&num; Excel数据有效性</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2ldx97.html">【Oracle 集群】ORACLE DATABASE 11G RAC 知识图文详细教程之RAC 工作原理和相关组件（三）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9344n83.html">年终巨献 史上最全 &mdash;&mdash;LINQ to SQL语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlr4eqo.html">php内核分析（三）－全局变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j3dgq5.html">STemwin汉字显示</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
